#include <NTDDK.H>
#include <windef.h>
#include "LDasm.h"

#define NT_DEVICE_NAME					L"\\Device\\CallHookKeInsertQueueApc"
#define DOS_DEVICE_NAME				L"\\DosDevices\\CallHookKeInsertQueueApc"

#define IOCTL_BASE	0x800

#define MY_CTL_CODE(i) \
	CTL_CODE(FILE_DEVICE_UNKNOWN, IOCTL_BASE+i, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_StartProt		MY_CTL_CODE(1) //ʼ
#define IOCTL_StopProt		MY_CTL_CODE(2) //ֹͣ

#define MEM_TAG 'TMEM'

NTKERNELAPI PEPROCESS IoThreadToProcess (IN PETHREAD Thread);

PEPROCESS ProtectedProcess;//ҪĽ̶

typedef VOID (__fastcall *KIINSERTQUEUEAPC)
(
 IN PKAPC Apc,
 IN KPRIORITY Increment
);

typedef BOOLEAN (__stdcall *KEINSERTQUEUEAPC)
(
 IN PKAPC Apc,
 IN PVOID SystemArgument1,
 IN PVOID SystemArgument2,
 IN KPRIORITY Increment
);

KIINSERTQUEUEAPC KiInsertQueueApc=NULL;
KEINSERTQUEUEAPC KeInsertQueueApc=NULL;

KIRQL f_oldirql;
KSPIN_LOCK f_spinlock;

ULONG GetKiInsertQueueApcFromKeInsertQueueApc()
{
	UCHAR *cPtr, *pOpcode;
	ULONG Length, CallCount=1, ETAddr=0;
	ULONG AddressOf_KeInsertQueueApc,AddressOf_KiInsertQueueApc=0;
	//Get KeInsertQueueApc Address
	AddressOf_KeInsertQueueApc=(ULONG)KeInsertQueueApc;
	//Get KiInsertQueueApc Address
	for (cPtr = (PUCHAR)AddressOf_KeInsertQueueApc; cPtr < (PUCHAR)AddressOf_KeInsertQueueApc + PAGE_SIZE; cPtr += Length) 
	{
		Length = SizeOfCode(cPtr, &pOpcode);
		if (!Length) return ETAddr;	
		if (*pOpcode == 0xE8)
		{
			CallCount++;
			if (CallCount==3) //XP: The Third e8 is KiInsertQueueApc
			{
				AddressOf_KiInsertQueueApc=(*(PULONG)(pOpcode+1)+(ULONG)cPtr + 5);
				DbgPrint("KiInsertQueueApc Address = %X",AddressOf_KiInsertQueueApc);
				break;
			}
		}
	}	
	ETAddr=AddressOf_KiInsertQueueApc;
	return ETAddr;
}
void MemOpen()
{
	__asm {   
		cli
		mov  eax,cr0
		and  eax,not 10000h
		mov  cr0,eax
	}
}

void MemClose()
{
	__asm {    
		mov  eax,cr0
		or   eax,10000h
		mov  cr0,eax
		sti
	} 
}

VOID fake_KiInsertQueueApc(IN PKAPC Apc,IN KPRIORITY Increment)
{
	PETHREAD txtd;
	PEPROCESS txps;
	txtd=(PETHREAD)(*(PULONG)((ULONG)Apc->Thread));
	txps=IoThreadToProcess(txtd);
	if (txps!=ProtectedProcess)
	{
		KiInsertQueueApc(Apc,Increment);
	}
}

// StartAddrַ ʼOldAddr 滻ΪNewAddrַ  SIZE 
BOOL CallAddrHook(PVOID StartAddr,PVOID OldAddr,PVOID NewAddr,ULONG Size)
{
	PUCHAR cPtr, pOpcode;
	ULONG Length,Tmp;
	PMDL pMdl;
	for (cPtr=StartAddr;(ULONG)cPtr<(ULONG)StartAddr+Size;cPtr += Length)
	{
		Length = SizeOfCode(cPtr, &pOpcode);//㵱ǰָ
		if (!Length) break;
		if (Length ==5 && *cPtr==0xE8)// ǰ5 ҵһֽΪE8 
		{//ΪCALLõƫ  ǻҪмƫ
			if ( (ULONG)OldAddr-(ULONG)cPtr-5 == *(PULONG)(cPtr+1)) //жϵǰǷΪOldAddrCALLԵַ 
			{
				DbgPrint("ULONG cPtr=%x",(ULONG)cPtr);
				Tmp=(ULONG)NewAddr-(ULONG)cPtr-5;//ǵCALLַƫ
				//MDL
				pMdl=IoAllocateMdl(cPtr+1, 4, FALSE, FALSE, NULL);
				if (pMdl)
				{
					//ڴҳ
					__try
					{
						MmProbeAndLockPages(pMdl, KernelMode, IoWriteAccess);
						//ж
						f_oldirql = KeRaiseIrqlToDpcLevel();
						//벢ʹ
						KeInitializeSpinLock(&f_spinlock);
						KeAcquireSpinLock(&f_spinlock,&f_oldirql);
						//HOOK
						MemOpen();
						*(PULONG)(cPtr+1)=Tmp;//ֱ滻ΪǵFAKEַ   
						MemClose();
						return TRUE;
					}
					__except(EXCEPTION_EXECUTE_HANDLER)
					{
						IoFreeMdl(pMdl);
					}
				}
			}
		}
	}
	return FALSE;
}

void HookKeInsertQueueApc()
{
	UNICODE_STRING uniFuncName;
	RtlInitUnicodeString(&uniFuncName,L"KeInsertQueueApc");
	KeInsertQueueApc=MmGetSystemRoutineAddress(&uniFuncName);
	CallAddrHook(KeInsertQueueApc,KiInsertQueueApc,fake_KiInsertQueueApc,PAGE_SIZE);
}

void UnhookKeInsertQueueApc()
{
	CallAddrHook(KeInsertQueueApc,fake_KiInsertQueueApc,KiInsertQueueApc,PAGE_SIZE);
}